=== modified file 'doc/QUICKSTART'
--- doc/QUICKSTART	2011-04-18 17:53:40 +0000
+++ doc/QUICKSTART	2011-06-10 04:46:04 +0000
@@ -82,7 +82,7 @@
 apt-get install launch-control
 sudo -u www-data python /usr/lib/launch-control/manage.py createsuperuser
 
-Modify the server in job file doc/abrek-ltp-job.json to local launch-control
+Modify the server in job file doc/lava-ltp-job.json to local launch-control
 url, like:
 http://127.0.0.1/launch-control
     {
@@ -114,5 +114,5 @@
 
 From the toplevel, run (as root):
 
-    ./lava-dispatch doc/abrek-ltp-job.json
+    ./lava-dispatch doc/lava-ltp-job.json
 

=== renamed file 'doc/abrek-ltp-job.json' => 'doc/lava-ltp-job'
--- doc/abrek-ltp-job.json	2011-04-12 04:23:11 +0000
+++ doc/lava-ltp-job	2011-06-10 04:46:04 +0000
@@ -12,7 +12,7 @@
         }
     },
     {
-      "command": "install_abrek",
+      "command": "lava_test_install",
       "parameters":
         {
             "tests": ["ltp"]
@@ -22,7 +22,7 @@
       "command": "boot_linaro_image"
     },
     {
-      "command": "test_abrek",
+      "command": "lava_test_run",
       "parameters":
         {
           "test_name": "ltp"
@@ -32,8 +32,8 @@
       "command": "submit_results",
       "parameters":
         {
-          "server": "http://dashboard.linaro.org",
-          "stream": "panda01-ltp"
+          "server": "http://validation.linaro.org/launch-control",
+          "stream": "/anonymous/panda01-ltp/"
         }
     }
   ]

=== removed file 'lava/dispatcher/actions/abrek.py'
--- lava/dispatcher/actions/abrek.py	2011-05-20 22:41:49 +0000
+++ lava/dispatcher/actions/abrek.py	1970-01-01 00:00:00 +0000
@@ -1,88 +0,0 @@
-#!/usr/bin/python
-from lava.dispatcher.actions import BaseAction
-from lava.dispatcher.client import OperationFailed
-from lava.dispatcher.config import LAVA_RESULT_DIR, MASTER_STR, TESTER_STR
-
-class cmd_test_abrek(BaseAction):
-    def run(self, test_name, timeout=-1):
-        #Make sure in test image now
-        client = self.client
-        client.in_test_shell()
-        client.run_shell_command('mkdir -p %s' % LAVA_RESULT_DIR,
-            response = TESTER_STR)
-        client.export_display()
-        client.run_shell_command(
-            'abrek run %s -o %s/%s.bundle' % (
-                test_name, LAVA_RESULT_DIR, test_name),
-            response = TESTER_STR, timeout = timeout)
-
-class cmd_install_abrek(BaseAction):
-    """
-    abrek test tool deployment to test image rootfs by chroot
-    """
-    def run(self, tests, timeout=2400):
-        client = self.client
-        #Make sure in master image
-        #, or exception can be caught and do boot_master_image()
-        try:
-            client.in_master_shell()
-        except:
-            client.boot_master_image()
-
-        #install bazaar in tester image
-        client.run_shell_command(
-            'mkdir -p /mnt/root',
-            response = MASTER_STR)
-        client.run_shell_command(
-            'mount /dev/disk/by-label/testrootfs /mnt/root',
-            response = MASTER_STR)
-        client.run_shell_command(
-            'cp -f /mnt/root/etc/resolv.conf /mnt/root/etc/resolv.conf.bak',
-            response = MASTER_STR)
-        client.run_shell_command(
-            'cp -L /etc/resolv.conf /mnt/root/etc',
-            response = MASTER_STR)
-        #eliminate warning: Can not write log, openpty() failed
-        #                   (/dev/pts not mounted?), does not work
-        client.run_shell_command(
-            'mount --rbind /dev /mnt/root/dev',
-            response = MASTER_STR)
-        client.run_shell_command(
-            'chroot /mnt/root apt-get update',
-            response = MASTER_STR)
-        #Install necessary packages for build abrek
-        client.run_shell_command(
-            'chroot /mnt/root apt-get -y install bzr python-apt python-distutils-extra',
-            response = MASTER_STR, timeout=2400)
-        client.run_shell_command(
-            'chroot /mnt/root bzr branch lp:abrek',
-            response = MASTER_STR)
-        client.run_shell_command(
-            'chroot /mnt/root sh -c "cd abrek && python setup.py install"',
-            response = MASTER_STR)
-
-        #Test if abrek installed
-        try:
-            client.run_shell_command(
-                'chroot /mnt/root abrek help',
-                response = "list-tests")
-        except:
-            raise OperationFailed("abrek deployment failed")
-
-        for test in tests:
-            client.run_shell_command(
-                'chroot /mnt/root abrek install %s' % test,
-                response = MASTER_STR)
-        #clean up
-        client.run_shell_command(
-            'cp -f /mnt/root/etc/resolv.conf.bak /mnt/root/etc/resolv.conf',
-            response = MASTER_STR)
-        client.run_shell_command(
-            'rm -rf /mnt/root/abrek',
-            response = MASTER_STR)
-        client.run_shell_command(
-            'cat /proc/mounts | awk \'{print $2}\' | grep "^/mnt/root/dev" | sort -r | xargs umount',
-            response = MASTER_STR)
-        client.run_shell_command(
-            'umount /mnt/root',
-            response = MASTER_STR)