=== modified file 'doc/android-new-kernel.json'
--- doc/android-new-kernel.json	2011-08-16 06:15:23 +0000
+++ doc/android-new-kernel.json	2011-10-09 03:11:54 +0000
@@ -29,7 +29,7 @@
       "command": "submit_results_on_host",
       "parameters":
         {
-          "server": "http://validation.linaro.org/launch-control",
+          "server": "http://validation.linaro.org/lava-server/RPC2/",
           "stream": "/anonymous/android-panda01-basic/"
         }
     }

=== added file 'doc/changes.rst'
--- doc/changes.rst	1970-01-01 00:00:00 +0000
+++ doc/changes.rst	2011-10-09 07:17:05 +0000
@@ -0,0 +1,37 @@
+Version History
+***************
+
+.. _version_0_3:
+
+Version 0.3(Milestone 11.09)
+============================
+
+* Local configuration data for lava-dispatcher is now stored in config files. (Please look at the README and examples of configuration)
+
+* A new kernel package can be specified for testing directly in the lava-dispatcher
+
+* The lava-dispatcher is now available as a package.
+
+* Bug fixes: #836700, #796618, #831784, #833246, #844462, #856247, #813919, #833181, #844299, #844301, #844446, #845720, #850983, #827727, #853657.
+
+.. _version_0_2:
+
+Version 0.2(Milestone 11.08)
+============================
+
+* Transferring results from the test system to the dispatcher is now more reliable
+
+* i.mx53 support added
+
+* Support added for installing out-of-tree tests
+
+* Bug fixes: #815986, #824622, #786005, #821385
+
+Version 0.1(Milestone 11.07)
+============================
+
+* LAVA dispatcher now tries to make as much progress in the test run as possible despite failures of previous actions, and keeps track of which actions passed or failed rather than just whether the whole test run completed or not.
+
+* Trial support for snowball board
+
+* Bug fixes: #791725, #806571, #768453

=== added file 'doc/conf.py'
--- doc/conf.py	1970-01-01 00:00:00 +0000
+++ doc/conf.py	2011-10-09 09:46:11 +0000
@@ -0,0 +1,227 @@
+# -*- coding: utf-8 -*-
+#
+# LAVA Dispatcher documentation build configuration file, created by
+# sphinx-quickstart on Sat Sep 24 18:20:56 2011.
+#
+# This file is execfile()d with the current directory set to its containing dir.
+#
+# Note that not all possible configuration values are present in this
+# autogenerated file.
+#
+# All configuration values have a default; values that are commented out
+# serve to show the default.
+
+import sys, os
+
+# If extensions (or modules to document with autodoc) are in another directory,
+# add these directories to sys.path here. If the directory is relative to the
+# documentation root, use os.path.abspath to make it absolute, like shown here.
+#sys.path.insert(0, os.path.abspath('.'))
+sys.path.append(os.path.abspath('..'))
+
+# -- General configuration -----------------------------------------------------
+
+# If your documentation needs a minimal Sphinx version, state it here.
+#needs_sphinx = '1.0'
+
+# Add any Sphinx extension module names here, as strings. They can be extensions
+# coming with Sphinx (named 'sphinx.ext.*') or your custom ones.
+extensions = [
+        'sphinx.ext.autodoc',
+        'sphinx.ext.doctest',
+        'sphinx.ext.intersphinx',
+        'sphinx.ext.todo',
+        'sphinx.ext.coverage',
+        'sphinx.ext.viewcode']
+
+# Configuration for sphinx.ext.todo
+
+todo_include_todos = True
+
+# Add any paths that contain templates here, relative to this directory.
+templates_path = []
+
+# The suffix of source filenames.
+source_suffix = '.rst'
+
+# The encoding of source files.
+#source_encoding = 'utf-8-sig'
+
+# The master toctree document.
+master_doc = 'index'
+
+# General information about the project.
+project = u'LAVA Dispatcher'
+copyright = u'2011, Linaro Validation Team'
+
+# The version info for the project you're documenting, acts as replacement for
+# |version| and |release|, also used in various other places throughout the
+# built documents.
+#
+# The short X.Y version.
+version = '0.3'
+# The full version, including alpha/beta/rc tags.
+release = '0.3'
+
+# The language for content autogenerated by Sphinx. Refer to documentation
+# for a list of supported languages.
+#language = None
+
+# There are two options for replacing |today|: either, you set today to some
+# non-false value, then it is used:
+#today = ''
+# Else, today_fmt is used as the format for a strftime call.
+#today_fmt = '%B %d, %Y'
+
+# List of patterns, relative to source directory, that match files and
+# directories to ignore when looking for source files.
+exclude_patterns = ['_build']
+
+# The reST default role (used for this markup: `text`) to use for all documents.
+#default_role = None
+
+# If true, '()' will be appended to :func: etc. cross-reference text.
+#add_function_parentheses = True
+
+# If true, the current module name will be prepended to all description
+# unit titles (such as .. function::).
+#add_module_names = True
+
+# If true, sectionauthor and moduleauthor directives will be shown in the
+# output. They are ignored by default.
+#show_authors = False
+
+# The name of the Pygments (syntax highlighting) style to use.
+pygments_style = 'sphinx'
+
+# A list of ignored prefixes for module index sorting.
+#modindex_common_prefix = []
+
+
+# -- Options for HTML output ---------------------------------------------------
+
+# The theme to use for HTML and HTML Help pages.  See the documentation for
+# a list of builtin themes.
+html_theme = 'default'
+
+# Theme options are theme-specific and customize the look and feel of a theme
+# further.  For a list of options available for each theme, see the
+# documentation.
+#html_theme_options = {}
+
+# Add any paths that contain custom themes here, relative to this directory.
+#html_theme_path = []
+
+# The name for this set of Sphinx documents.  If None, it defaults to
+# "<project> v<release> documentation".
+#html_title = None
+
+# A shorter title for the navigation bar.  Default is the same as html_title.
+#html_short_title = None
+
+# The name of an image file (relative to this directory) to place at the top
+# of the sidebar.
+#html_logo = None
+
+# The name of an image file (within the static path) to use as favicon of the
+# docs.  This file should be a Windows icon file (.ico) being 16x16 or 32x32
+# pixels large.
+#html_favicon = None
+
+# Add any paths that contain custom static files (such as style sheets) here,
+# relative to this directory. They are copied after the builtin static files,
+# so a file named "default.css" will overwrite the builtin "default.css".
+html_static_path = []
+
+# If not '', a 'Last updated on:' timestamp is inserted at every page bottom,
+# using the given strftime format.
+#html_last_updated_fmt = '%b %d, %Y'
+
+# If true, SmartyPants will be used to convert quotes and dashes to
+# typographically correct entities.
+#html_use_smartypants = True
+
+# Custom sidebar templates, maps document names to template names.
+#html_sidebars = {}
+
+# Additional templates that should be rendered to pages, maps page names to
+# template names.
+#html_additional_pages = {}
+
+# If false, no module index is generated.
+#html_domain_indices = True
+
+# If false, no index is generated.
+#html_use_index = True
+
+# If true, the index is split into individual pages for each letter.
+#html_split_index = False
+
+# If true, links to the reST sources are added to the pages.
+#html_show_sourcelink = True
+
+# If true, "Created using Sphinx" is shown in the HTML footer. Default is True.
+#html_show_sphinx = True
+
+# If true, "(C) Copyright ..." is shown in the HTML footer. Default is True.
+#html_show_copyright = True
+
+# If true, an OpenSearch description file will be output, and all pages will
+# contain a <link> tag referring to it.  The value of this option must be the
+# base URL from which the finished HTML is served.
+#html_use_opensearch = ''
+
+# This is the file name suffix for HTML files (e.g. ".xhtml").
+#html_file_suffix = None
+
+# Output file base name for HTML help builder.
+htmlhelp_basename = 'LAVADispatcherDoc'
+
+
+# -- Options for LaTeX output --------------------------------------------------
+
+# The paper size ('letter' or 'a4').
+#latex_paper_size = 'letter'
+
+# The font size ('10pt', '11pt' or '12pt').
+#latex_font_size = '10pt'
+
+# Grouping the document tree into LaTeX files. List of tuples
+# (source start file, target name, title, author, documentclass [howto/manual]).
+latex_documents = [
+  ('index', 'LAVADispatcher.tex', u'LAVA Dispatcher Documentation',
+   u'Linaro Validation Team', 'manual'),
+]
+
+# The name of an image file (relative to this directory) to place at the top of
+# the title page.
+#latex_logo = None
+
+# For "manual" documents, if this is true, then toplevel headings are parts,
+# not chapters.
+#latex_use_parts = False
+
+# If true, show page references after internal links.
+#latex_show_pagerefs = False
+
+# If true, show URL addresses after external links.
+#latex_show_urls = False
+
+# Additional stuff for the LaTeX preamble.
+#latex_preamble = ''
+
+# Documents to append as an appendix to all manuals.
+#latex_appendices = []
+
+# If false, no module index is generated.
+#latex_domain_indices = True
+
+
+# -- Options for manual page output --------------------------------------------
+
+# One entry per manual page. List of tuples
+# (source start file, name, description, authors, manual section).
+man_pages = [
+    ('index', 'lavadispatcher', u'LAVA Dispatcher Documentation',
+     [u'Linaro Validation Team'], 1)
+]

=== added file 'doc/index.rst'
--- doc/index.rst	1970-01-01 00:00:00 +0000
+++ doc/index.rst	2011-10-09 09:46:11 +0000
@@ -0,0 +1,87 @@
+.. LAVA Dispatcher documentation master file, created by
+   sphinx-quickstart on Fri Sep 23 10:15:12 2011.
+   You can adapt this file completely to your liking, but it should at least
+   contain the root `toctree` directive.
+
+LAVA Dispatcher Documentation
+=============================
+LAVA Dispatcher is to dispatch test jobs from server(master node) to the target boards in validation farm, and publish the test result back to dashboard. It is scheduled by validation scheduler, and it could also run as standalone.
+
+.. seealso:: To learn more about LAVA see https://launchpad.net/lava
+
+Contents:
+
+.. toctree::
+   :maxdepth: 1
+
+   installation.rst
+   jobfile.rst
+   usage.rst
+   changes.rst
+   todo.rst
+
+
+60 second example
+=================
+
+This example will run on Ubuntu Lucid and beyond::
+
+ $ sudo add-apt-repository ppa:linaro-validation/ppa
+ $ sudo apt-get update
+ $ sudo apt-get install lava-dispatcher
+ $ sudo lava-dispatch ./lava-ltp-job.json
+ (lava-ltp-job.json can be found in lava-dispatcher/doc)
+
+.. seealso:: For detailed installation instructions see :ref:`installation`
+.. seealso:: For writing a new dispatcher job file see :ref:`jobfile`
+
+Features
+========
+
+* Ability to accept, parse and run a job which consists of different actions and test cases, then upload test result to LAVA Dashboard on an ARM target system.
+* Support ARM target boards including Beagle, Panda, i.MX51 EVK, i.MX53 QuickStart and Snowball, more boards support is coming.
+* Support Android system on Beagle, Panda and i.MX53 QuickStart board, more boards support is coming.
+* Support for local user-defined configuration data for boards, device types.
+* Extensible device types and boards configuration editing, can add new device and new board.
+* Make use of the output of LAVA test, which is Linaro Dashboard Bundle format, upload test results to the LAVA Dashboard for result archiving and analysis.
+
+.. seealso:: See what's new in :ref:`version_0_3`
+
+
+Latest documentation
+====================
+
+This documentation may be out of date, we try to make sure that all the latest
+and greatest releases are always documented on http://lava-dispatcher.readthedocs.org/
+
+
+Source code, bugs and patches
+=============================
+
+The project is maintained on Launchpad at http://launchpad.net/lava-dispatcher/.
+
+You can get the source code with bazaar using ``bzr branch lp:lava-dispatcher``.
+Patches can be submitted using Launchpad merge proposals (for introduction to
+this and topic see https://help.launchpad.net/Code/Review).
+
+Please report all bugs at https://bugs.launchpad.net/lava-dispatcher/+filebug.
+
+Most of the team is usually available in ``#linaro`` on ``irc.freenode.net``.
+Feel free to drop by to chat and ask questions.
+
+Indices and tables
+==================
+
+.. toctree::
+   :maxdepth: 2
+
+   installation.rst
+   jobfile.rst
+   usage.rst
+   changes.rst
+   todo.rst
+
+* :ref:`genindex`
+* :ref:`modindex`
+* :ref:`search`
+

=== added file 'doc/installation.rst'
--- doc/installation.rst	1970-01-01 00:00:00 +0000
+++ doc/installation.rst	2011-10-09 07:17:05 +0000
@@ -0,0 +1,176 @@
+
+.. _installation:
+
+Installation
+============
+
+Prerequisites
+^^^^^^^^^^^^^
+
+The following debian packages are needed to use LAVA Dispatcher:
+
+* cu - for serial port control
+* conmux - for console management
+* python >= 2.6
+* python-testrepository - for running unit tests
+* python-sphinx - for building documentation
+
+The following python module are needed to use LAVA Dispatcher:
+
+* pexpect
+
+A SD/MMC card containing a 'master image'.
+
+Creating a SD/MMC card with master image
+^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
+
+You will need to have a card containing a 'master image' for your
+board.  The process of creating a master image is outlined on
+https://wiki.linaro.org/Platform/Validation/Specs/MasterBootImage.
+
+The master image is a stable, default image the system can boot into for deployment and recovery. It's a simple modification of an existing stable image, and does not take long to create. Once you've created one for your board, you may want to consider making a dd image of it for future use. We do not provide dd images for this already. Due to differences in size of SD cards, it's likely that doing so would either waste a lot of space if you have a larger card, or be competely useless if you have a smaller sd card. 
+
+Setup the image and test partitions
+-----------------------------------
+
+* Start with a stable Linaro image from the current, or previous cycle. For instance, the nano, or headless images make a good starting place. Using linaro-media-create, create an sdcard with this image, and the hardware pack for your board. (minimum 8GB sd card is recommended, but 4GB can work also).
+* Using parted (or gparted, etc), shrink the root partition so that only 1-1.5GB or so is used (Make sure to leave at least 2G free on the card).
+* Create an additional primary partition (should normally be partition 3), of about 70MB. Format it as vfat and give it the label testboot.
+* Create partition 4 as an Extended partition, using the remainder of the space on the card.
+* Create partition 5 (logical partition) using 2GB. Format it as ext3, and give it the label testrootfs 
+* Finally, create one more logical partition using the remainder of the space. It should be vfat formatted, and have the label sdcard (NB: This is only needed if you want to test android images. If you don't wish to test android, this can be skipped) 
+
+Prepare the master image
+------------------------
+
+* Boot the image created above on your test board, and attach to the serial console
+* Ensure that networking is set up so that the default network interface is automatically started. Generally you will want to use dhcp for this. For example, if your network interface is eth0, make sure that /etc/network/interfaces contains something like this::
+
+    auto usb0
+    iface usb0 inet dhcp
+
+* Edit /etc/hostname and /etc/hosts to change the hostname to "master". This will allow easy detection of which image we are booted into.
+* Install the following packages:
+    * wget
+    * dosfstools
+* If you want to test your own build kernel by a deb package(see following example  job file for detail), you need to add linaro-media-tools support in master image::
+
+    # apt-get install bzr python-distutils-extra python-testtools python-parted command-not-found python-yaml python-beautifulsoup python-wxgtk2.6
+    # bzr branch lp:linaro-media-tools
+    # cd linaro-media-tools
+    # ./setup.py install
+
+Setting up serial access
+^^^^^^^^^^^^^^^^^^^^^^^^
+
+To talk to the target test systems, the dispatcher uses a tool called conmux. If you are running Ubuntu 11.04 or later, conmux is in the archives and can be easily installed [TODO: point to ppa for conmux installation -lt 11.04].
+
+Configuring cu and conmux
+-------------------------
+
+For LAVA development and testing using only locally attached resources,
+you should be able to make use of most features, even without the use of
+special equipment such as a console server.
+
+First install conmux and cu::
+
+    sudo add-apt-repository ppa:linaro-maintainers/tools
+    sudo apt-get update
+    sudo apt-get install conmux cu
+
+Configuring cu
+--------------
+
+You should be able to type commands and interact with the shell inside
+conmux-console.  If you cannot, run "sudo stop conmux" and try running
+'sg dialout "cu -l ttyUSB0 -s 115200"'.  If that doesn't work, you
+probably need to add some files to /etc/uucp.  Add ::
+
+    port ttyUSB0
+    type direct
+    device /dev/ttyUSB0
+    hardflow false
+    speed 115200
+
+to /etc/uucp/port and append ::
+
+    system  panda01
+    port    ttyUSB0
+    time    any
+
+to /etc/uucp/sys.
+
+Configuring conmux
+------------------
+
+Connect a development board to a local serial device (e.g. ttyUSB0). You may have permission problem with cu running as root under conmux.
+
+Configuration files for conmux are stored under /etc/conmux. It can be configured for either local connections (via serial or usb), or remote configurations such as console servers. Configurations for each board you wish to connect to should be stored in it's own .cf file under /etc/conmux. 
+
+Create a configuration file for your board under /etc/conmux which
+should look something like this::
+
+    listener panda01
+    application console 'panda01 console' 'cu -l /dev/ttyUSB0 -s 115200'
+
+Make sure to give the file a '.cf' extension (e.g. panda01.cf).
+
+If you see this permission problem when running cu, you can try
+adjusting your .cf file to call cu using sg, and the group name owning
+the device.  For example::
+
+    sg dialout "cu -l ttyUSB0 -s 115200"
+
+Finally restart conmux::
+
+    sudo stop conmux
+    sudo start conmux
+
+You can test the connection using::
+
+    conmux-console panda01
+    (use ~$quit to exit)
+
+Another example config, a remote console server on 10.1.1.1 port 7777 attached to a board we will call beagle01::
+
+    listener beagle01 
+    socket console 'beagle01 console' '10.1.1.1:7777'
+
+.. seealso:: If you are using a snowball with serial USB, then you'll need to follow `this guide <https://wiki.linaro.org/Platform/Validation/LAVA/Documentation/GettingSnowballWorking>`_
+
+Installation Options
+^^^^^^^^^^^^^^^^^^^^
+
+There are several installation options available:
+
+Using Ubuntu PPAs
+-----------------
+
+For Ubuntu 10.04 onward there is a stable PPA (personal package archive):
+
+* ppa:linaro-validation/ppa
+
+To add a ppa to an Ubuntu system use the add-apt-repository command::
+
+    sudo add-apt-repository ppa:linaro-validation/ppa
+
+After you add the PPA you need to update your package cache::
+
+    sudo apt-get update
+
+Finally you can install the package, it is called `lava-dispatcher`::
+
+    sudo apt-get install lava-dispatcher
+
+
+Using source tarball
+--------------------
+
+To install from source you must first obtain a source tarball from bazzar branch or from `Launchpad <https://launchpad.net/lava-dispatcher/+download>`_::
+
+    bzr branch lp:lava-dispatcher
+
+To install the package unpack the tarball and run::
+
+    sudo python setup.py install
+

=== added file 'doc/jobfile.rst'
--- doc/jobfile.rst	1970-01-01 00:00:00 +0000
+++ doc/jobfile.rst	2011-10-09 07:17:05 +0000
@@ -0,0 +1,165 @@
+.. _jobfile:
+
+Writing a Dispatcher Job File
+*****************************
+
+Linaro Ubuntu Images
+====================
+
+Here's an example of a job file to run the stream test on an Ubuntu based Linaro Image. Stream is a small, fast test, and great for testing that everything works OK::
+
+    {
+      "job_name": "foo",
+      "target": "panda01",
+      "timeout": 18000,
+      "actions": [
+        {
+          "command": "deploy_linaro_image",
+          "parameters":
+            {
+              "rootfs": "http://snapshots.linaro.org/11.05-daily/linaro-developer/20110208/0/images/tar/linaro-n-developer-tar-20110208-0.tar.gz",
+              "hwpack": "http://snapshots.linaro.org/11.05-daily/linaro-hwpacks/panda/20110208/0/images/hwpack/hwpack_linaro-panda_20110208-0_armel_supported.tar.gz"
+            }
+        },
+        {
+          "command": "lava_test_install",
+          "parameters":
+            {
+                "tests": ["stream"]
+            }
+        },
+        {
+          "command": "boot_linaro_image"
+        },
+        {
+          "command": "lava_test_run",
+          "parameters":
+            {
+              "test_name": "stream"
+            }
+        },
+        {
+          "command": "submit_results",
+          "parameters":
+            {
+              "server": "http://localhost/lava-server/RPC2/",
+              "stream": "/anonymous/test/"
+            }
+        }
+      ]
+    }
+
+Linaro Ubuntu Images with new kernel
+====================================
+Here's an example showing how to test a new kernel, new kernel is specified by "kernel_matrix". First parameter is the deb package which contains a kernel, and second one is the prefix of the deb package which will be removed from existing rootfs before installing the first deb::
+
+    {
+      "job_name": "fpp",
+      "target": "mx53loco01",
+      "timeout": 6000,
+      "actions": [
+        {
+          "command": "deploy_linaro_image",
+          "parameters":
+            {
+              "rootfs": "http://snapshots.linaro.org/11.05-daily/linaro-nano/20110612/0/images/tar/nano-n-tar-20110612-0.tar.gz",
+              "hwpack": "http://snapshots.linaro.org/11.05-daily/linaro-hwpacks/lt-mx53loco/20110609/0/images/hwpack/hwpack_linaro-lt-mx53loco_20110609-0_armel_supported.tar.gz",
+              "kernel_matrix":["http://pkgserver/original/linux-image-2.6.38-1000-linaro-lt-mx5_2.6.38-1000.7_armel.deb", "linux-image-2.6.38"]
+            }
+        },
+        {
+          "command": "boot_linaro_image"
+        },
+        {
+          "command": "submit_results",
+          "parameters":
+            {
+              "server": "http://validation.linaro.org/lava-server/RPC2/",
+              "stream": "/anonymous/testresult/"
+            }
+        }
+      ]
+    }
+
+And an example for Android images, it use a boot partition tarball specified by "pkg" directly, it will replace the files in tarball to boot partition::
+
+    {
+      "job_name": "android_new_kernel",
+      "image_type": "android",
+      "target": "panda01",
+      "timeout": 18000,
+      "actions": [
+        {
+          "command": "deploy_linaro_android_image",
+          "parameters":
+            {
+              "boot": "https://android-build.linaro.org/jenkins/job/linaro-android_leb-panda/61/artifact/build/out/target/product/pandaboard/boot.tar.bz2",
+              "system": "https://android-build.linaro.org/jenkins/job/linaro-android_leb-panda/61/artifact/build/out/target/product/pandaboard/system.tar.bz2",
+              "data": "https://android-build.linaro.org/jenkins/job/linaro-android_leb-panda/61/artifact/build/out/target/product/pandaboard/userdata.tar.bz2",
+              "pkg": "https://android-build.linaro.org/jenkins/job/linaro-android_leb-panda/171/artifact/build/out/target/product/pandaboard/boot.tar.bz2"
+            },
+          "metadata":
+            {
+              "rootfs.type": "android",
+              "rootfs.build": "61"
+            }
+        },
+        {
+          "command": "boot_linaro_android_image"
+        },
+        {
+          "command": "test_android_basic"
+        },
+        {
+          "command": "submit_results_on_host",
+          "parameters":
+            {
+              "server": "http://validation.linaro.org/lava-server/RPC2/",
+              "stream": "/anonymous/android-panda01-basic/"
+            }
+        }
+      ]
+    }
+
+
+Linaro Android Images
+=====================
+
+Here's an example showing how to run 0xbench on a Linaro Android image::
+
+    {
+      "image_type": "android", 
+      "actions": [
+        {
+          "command": "deploy_linaro_android_image", 
+          "parameters": {
+            "data": "https://android-build.linaro.org/jenkins/job/linaro-android_leb-panda/98/artifact/build/out/target/product/pandaboard/userdata.tar.bz2", 
+            "boot": "https://android-build.linaro.org/jenkins/job/linaro-android_leb-panda/98/artifact/build/out/target/product/pandaboard/boot.tar.bz2", 
+            "system": "https://android-build.linaro.org/jenkins/job/linaro-android_leb-panda/98/artifact/build/out/target/product/pandaboard/system.tar.bz2"
+          }, 
+          "metadata": {
+            "android.name": "linaro-android_leb-panda", 
+            "android.build": "98", 
+            "android.url": "https://android-build.linaro.org/builds/~linaro-android/leb-panda/#build=98"
+          }
+        }, 
+        {
+          "command": "boot_linaro_android_image"
+        }, 
+        {
+          "command": "test_android_0xbench"
+        }, 
+        {
+          "command": "submit_results", 
+          "parameters": {
+            "result_disk": "sdcard", 
+            "stream": "/anonymous/android/", 
+            "server": "http://localhost/lava-server/RPC2/"
+          }
+        }
+      ], 
+      "target": "panda01", 
+      "timeout": 18000, 
+      "name": "test job"
+    }
+

=== added file 'doc/todo.rst'
--- doc/todo.rst	1970-01-01 00:00:00 +0000
+++ doc/todo.rst	2011-10-09 09:46:11 +0000
@@ -0,0 +1,4 @@
+List of items that need work
+============================
+
+.. todolist::

=== added file 'doc/usage.rst'
--- doc/usage.rst	1970-01-01 00:00:00 +0000
+++ doc/usage.rst	2011-10-09 09:46:11 +0000
@@ -0,0 +1,64 @@
+.. _usage:
+
+=====
+Usage
+=====
+
+Workflow Overview
+=================
+
+LAVA Dispatcher can be used in two different ways. One is standalone (without
+the LAVA Scheduler) and another is managed (when LAVA Dispatcher is controlled
+by the LAVA Scheduler).
+
+Standalone usage
+^^^^^^^^^^^^^^^^
+
+In standalone mode a human operator installs LAVA Dispatcher on some device
+(development board, laptop or other computer or a virtual machine), edits the
+job file that are to be executed and then executes them manually (by manually
+running LAVA Dispatcher, the actual execution process are non-interactive).
+
+Typically this mode is based on the following sequence of commands:
+
+#. Install lava-dispatcher (from PPA or source) along with the required dependencies on LAVA Server.
+#. Configure local or remote development boards and device types.
+#. Add or edit job files which are to be executed.
+#. Execute dispatcher manually: $ sudo lava-dispatch ./lava-ltp-job.json
+
+At last dispatcher will publish the test results to LAVA Dashboard.
+
+Usage with the LAVA Scheduler
+^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
+
+The scheduler is useful for automating LAVA Dispatcher environment setup, describing test scenarios (the list of tests to invoke) and finally storing the results in the LAVA dashboard.
+
+Typically this mode is based on the following sequence of commands:
+
+#. Install lava-dispatcher (from PPA or source) along with the required dependencies on LAVA Server.
+#. Configure local or remote development boards and device types.
+#. Add or edit job files which are to be executed.
+#. Configure LAVA Scheduler to execute job files.
+
+Debug
+^^^^^
+    
+Debug 
+
+.. todo::
+
+    Describe how to collect enough information to debug dispatcher when the job execution failed.
+
+Check test result on LAVA Dashboard
+===================================
+
+.. todo::
+
+    Describe how to view test results on dashboard.
+
+Debug with serial log
+==============================
+
+.. todo::
+
+    Describe the information including logging information/warning and exception information.