=== modified file 'doc/QUICKSTART'
--- doc/QUICKSTART	2011-09-09 04:53:56 +0000
+++ doc/QUICKSTART	2011-12-22 06:11:18 +0000
@@ -113,15 +113,15 @@
 If you want to upload the results to a local dashboard instance, you
 need to set one of those up.  XXX link to doc on this!
 
-Modify the server in job file doc/lava-ltp-job.json to local launch-control
-url, like:
+Modify the server in job file doc/examples/jobs/lava-ltp-job.json to local 
+lava-dashboard url, like:
 
     {
       "command": "submit_results",
       "parameters":
         {
-          "server": "http://staging.linaro.dev/lava-server",
-          "stream": "panda01-ltp"
+          "server": "http://staging.linaro.dev/lava-server/RPC2/",
+          "stream": "/anonymous/panda01-ltp/"
         }
     }
 
@@ -138,5 +138,5 @@
 
 From the toplevel, run (as root):
 
-    ./lava-dispatch doc/lava-ltp-job.json
+    ./lava-dispatch doc/examples/jobs/lava-ltp-job.json
 

=== modified file 'doc/changes.rst'
--- doc/changes.rst	2011-12-16 04:33:55 +0000
+++ doc/changes.rst	2011-12-22 06:11:18 +0000
@@ -3,13 +3,14 @@
 
 .. _version_0_4.1:
 
-Version 0.4.1
-=============
+Version 0.4.1(Milestone 11.12)
+==============================
 * Add support for Origen
 * Snowball default config fixes
 * Add support for new snowball hwpacks
 * Fix timeout usage in lava_test_install
 * Added logging for sending and expecting statements.
+* Bug fixes: #900990, #904544, #898525.
 
 .. _version_0_4:
 
@@ -25,65 +26,50 @@
 
 Version 0.3.5(Milestone 11.11)
 ==============================
-* have soft_reboot look for a message that both android and regular images print
-* update android demo job to download urls that will hopefully exist for a while
+* Have soft_reboot look for a message that both android and regular images print
+* Update android demo job to download urls that will hopefully exist for a while
 * First pass at adding plugin support for lava actions
 * Add a --validate switch for using the dispatcher to validate the schema
-* fix hang with add-apt-repository in oneiric
+* Fix hang with add-apt-repository in oneiric
 * Add LAVA support for Android on MX53 QS board
 * Allow passing an option to the install step for lava-android-test
-* increase timeout for waiting on the network to come up
-* fix pypi installations issues
+* Increase timeout for waiting on the network to come up
+* Fix pypi installations issues
 * Add l-m-c version to metadata
 * Merge improvement for bug 874594 so the default timeout is shorten to 20mins
-* fix demo job to install and run the same test
-* remove old android tests and LavaAndroidClient
-* move all the stuff that knows about conmux to a concrete subclass of a new connection abstract class
+* Fix demo job to install and run the same test
+* Remove old android tests and LavaAndroidClient
+* Move all the stuff that knows about conmux to a concrete subclass of a new connection abstract class
 
 .. _version_0_3_4:
 
 Version 0.3.4(Milestone 11.10)
 ==============================
-
 * Documentation for lava-dispatcher is now available from lava-dispatcher.readthedocs.org
-
 * Added support for snowball boards
-
 * Move bootloader prompt string to device_type configuration file
-
 * Bug fixes: #873043, #861115, #867858, #863091, #872948, #877045, #855384
 
 .. _version_0_3:
 
 Version 0.3(Milestone 11.09)
 ============================
-
 * Local configuration data for lava-dispatcher is now stored in config files. (Please look at the README and examples of configuration)
-
 * A new kernel package can be specified for testing directly in the lava-dispatcher
-
 * The lava-dispatcher is now available as a package.
-
 * Bug fixes: #836700, #796618, #831784, #833246, #844462, #856247, #813919, #833181, #844299, #844301, #844446, #845720, #850983, #827727, #853657.
 
 .. _version_0_2:
 
 Version 0.2(Milestone 11.08)
 ============================
-
 * Transferring results from the test system to the dispatcher is now more reliable
-
-* i.mx53 support added
-
+* i.MX53 support added
 * Support added for installing out-of-tree tests
-
 * Bug fixes: #815986, #824622, #786005, #821385
 
 Version 0.1(Milestone 11.07)
 ============================
-
 * LAVA dispatcher now tries to make as much progress in the test run as possible despite failures of previous actions, and keeps track of which actions passed or failed rather than just whether the whole test run completed or not.
-
 * Trial support for snowball board
-
 * Bug fixes: #791725, #806571, #768453

=== modified file 'doc/code.rst'
--- doc/code.rst	2011-10-24 02:35:49 +0000
+++ doc/code.rst	2011-12-22 06:11:18 +0000
@@ -5,8 +5,8 @@
 .. automodule:: lava_dispatcher
     :members:
 
-.. automodule:: lava_dispatcher.client
+.. automodule:: lava_dispatcher.client.base
     :members:
 
-.. automodule:: lava_dispatcher.android_client
+.. automodule:: lava_dispatcher.client.master
     :members:

=== modified file 'doc/conf.py'
--- doc/conf.py	2011-10-09 09:46:11 +0000
+++ doc/conf.py	2011-12-22 06:15:00 +0000
@@ -59,9 +59,9 @@
 # built documents.
 #
 # The short X.Y version.
-version = '0.3'
+version = '0.4'
 # The full version, including alpha/beta/rc tags.
-release = '0.3'
+release = '0.4.1'
 
 # The language for content autogenerated by Sphinx. Refer to documentation
 # for a list of supported languages.

=== added directory 'doc/examples/jobs'
=== renamed file 'doc/android-new-kernel.json' => 'doc/examples/jobs/android-new-kernel.json'
=== renamed file 'doc/lava-android-test-leb-panda.json' => 'doc/examples/jobs/lava-android-test-leb-panda.json'
=== renamed file 'doc/lava-ltp-job.json' => 'doc/examples/jobs/lava-ltp-job.json'
=== renamed file 'doc/lava-new-kernel.json' => 'doc/examples/jobs/lava-new-kernel.json'
=== renamed file 'doc/lava-out-of-tree-test-1.json' => 'doc/examples/jobs/lava-out-of-tree-test-1.json'
=== renamed file 'doc/lava-out-of-tree-test-2.json' => 'doc/examples/jobs/lava-out-of-tree-test-2.json'
=== renamed file 'doc/test_with_testoptions.json' => 'doc/examples/jobs/test_with_testoptions.json'